/*******************************************************************************
 * Copyright (c) 2003-2004, Michael Bartl
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the license in the file License.txt
 * 
 * Created on 10.06.2004
 *******************************************************************************/

package com.mbartl.viplugineclipse;


import org.eclipse.jface.text.BadLocationException;
import org.eclipse.jface.text.DocumentEvent;
import org.eclipse.jface.text.IDocument;
import org.eclipse.jface.text.IDocumentListener;

import com.mbartl.viimplementation.interfaces.AbstractDocumentAdapter;
import com.mbartl.viimplementation.layer.ViLayer;

/**
 * @author Michael Bartl
 */
public class DocumentAdapter extends AbstractDocumentAdapter implements IDocumentListener {
	private IDocument _document;
    private ViLayer _layer;

	/**
	 * @param document
	 */
	public DocumentAdapter(IDocument document) {
		_document = document;
        _document.addDocumentListener(this);
	}

	public String getText(int offset, int length) {
		try {
			return _document.get(offset, length);
		} catch (BadLocationException e) {
			e.printStackTrace();
			return null;
		}
	}

	public int getLength() {
		return _document.getLength();
	}

	public void replace(int start, int length, String text) {
		try {
			_document.replace(start, length, text);
		} catch (BadLocationException e) {
			e.printStackTrace();
		}
	}

    public void documentAboutToBeChanged(DocumentEvent event) {
        // not needed by viPlugin
    }

    public void documentChanged(DocumentEvent event) {
        _layer.updateDocument();
    }

    public void setLayer(ViLayer layer) {
        _layer = layer;
    }
}