/*******************************************************************************
 * Copyright (c) 2003-2004, Michael Bartl All rights reserved. This program and
 * the accompanying materials are made available under the terms of the license
 * in the file License.txt
 * 
 * Created on 10.08.2004
 ******************************************************************************/

package com.mbartl.viplugineclipse;

import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.ui.IEditorPart;
import org.eclipse.ui.IEditorReference;
import org.eclipse.ui.IWorkbenchWindow;

import com.mbartl.viimplementation.interfaces.IEditorManager;

public class EditorManager implements IEditorManager {

    private IWorkbenchWindow _window;

    public EditorManager(IWorkbenchWindow window) {
        _window = window;
    }

    public void next() {
        IEditorReference[] references = _window.getActivePage()
                .getEditorReferences();
        IEditorPart currentEditor = _window.getActivePage().getActiveEditor();
        for (int i = 0; i < references.length; i++) {
            if (references[i].getEditor(false) == currentEditor) {
                if (i == references.length - 1) {
                    _window.getActivePage().activate(
                            references[0].getPart(false));
                } else {
                    _window.getActivePage().activate(
                            references[i + 1].getPart(false));
                }
            }
        }
    }

    public void previous() {
        IEditorReference[] references = _window.getActivePage()
                .getEditorReferences();
        IEditorPart currentEditor = _window.getActivePage().getActiveEditor();
        for (int i = 0; i < references.length; i++) {
            if (references[i].getEditor(false) == currentEditor) {
                if (i == 0) {
                    _window.getActivePage().activate(
                            references[references.length - 1].getPart(false));
                } else {
                    _window.getActivePage().activate(
                            references[i - 1].getPart(false));
                }
            }
        }
    }
    
    public void saveAll() {
        IEditorReference[] references = _window.getActivePage()
                .getEditorReferences();
        for (int i = 0; i < references.length; i++) {
            IEditorPart part = references[i].getEditor(false);
            if (part != null) {
                IProgressMonitor pm = part.getEditorSite().getActionBars()
                .getStatusLineManager().getProgressMonitor();
                part.doSave(pm);
            }
        }
    }
}