/*******************************************************************************
 * Copyright (c) 2003-2004, Michael Bartl
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the license in the file License.txt
 * 
 * Created on 10.06.2004
 *******************************************************************************/

package com.mbartl.viplugineclipse;

import org.eclipse.ui.IPartListener;
import org.eclipse.ui.IWorkbenchPart;
import org.eclipse.ui.texteditor.ITextEditor;

import com.mbartl.viimplementation.layer.ViLayerManager;

/**
 * Controls lifecycle of individual ViLayers in the same window.
 * 
 * @author Michael Bartl
 */
public class ViPartListener implements IPartListener {

    /**
     * @see org.eclipse.ui.IPartListener#partActivated(org.eclipse.ui.IWorkbenchPart)
     */
    public void partActivated(IWorkbenchPart part) {
        ViPluginPlugin.getDefault().log("partActivated: " + part.toString());
        ActivateLayer.activateLayer(part);
    }

    /**
     * @see org.eclipse.ui.IPartListener#partBroughtToTop(org.eclipse.ui.IWorkbenchPart)
     */
    public void partBroughtToTop(IWorkbenchPart part) {
        ViPluginPlugin.getDefault().log("partBroughToTop: " + part.toString());
    }

    /**
     * @see org.eclipse.ui.IPartListener#partClosed(org.eclipse.ui.IWorkbenchPart)
     */
    public void partClosed(IWorkbenchPart part) {
        ViPluginPlugin.getDefault().log("partClosed: " + part.toString());
        if (part instanceof ITextEditor) {
            ViLayerManager.getInstance().removeViLayer(part.toString());
        }
    }

    /**
     * @see org.eclipse.ui.IPartListener#partDeactivated(org.eclipse.ui.IWorkbenchPart)
     */
    public void partDeactivated(IWorkbenchPart part) {
    	ViPluginPlugin.getDefault().log("partDeactivated: " + part.toString());
    }

    /**
     * @see org.eclipse.ui.IPartListener#partOpened(org.eclipse.ui.IWorkbenchPart)
     */
    public void partOpened(IWorkbenchPart part) {
        ViPluginPlugin.getDefault().log("partOpened: " + part.toString());
        ActivateLayer.activateLayer(part);
    }
}