/*******************************************************************************
 * Copyright (c) 2003-2004, Michael Bartl
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the license in the file License.txt
 * 
 * Created on 11.06.2004
 *******************************************************************************/

package com.mbartl.viplugineclipse;

import org.eclipse.jface.action.IStatusLineManager;

import com.mbartl.viimplementation.interfaces.IViStatusLineManager;
import com.mbartl.viplugineclipse.views.CommandoView;

/**
 * @author Michael Bartl
 */
public class ViStatusLineManager implements IViStatusLineManager {

    private IStatusLineManager _slm;

    public ViStatusLineManager(IStatusLineManager slm) {
        _slm = slm;
    }

    /**
     * either set the message in the viPlugin view or the statusline if the view
     * is not open
     */
    public void setMessage(String message) {
        CommandoView view = CommandoView.getDefault();
        if (view != null) {
            if (message.endsWith("/")) {
                view.setText("/");
                view.setFocus();
            }
            view.setMessage(message);
        } else {
            _slm.setMessage(message);
        }
    }
}
