/*******************************************************************************
 * Copyright (c) 2003-2004, Michael Bartl
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the license in the file License.txt
 * 
 * Created on 03.01.2005
 *******************************************************************************/

package com.mbartl.viplugineclipse.actions;

import org.eclipse.jface.action.Action;

import com.mbartl.viimplementation.command.actions.motion.PageDown;
import com.mbartl.viimplementation.layer.ViLayer;
import com.mbartl.viimplementation.layer.ViLayerManager;

/**
 * This is the standard insert mode CTRL-D command in VIM
 * @author Michael Bartl
 */
public class EraseOneLevelOfIndentation extends Action {

	public static final String ACTIONID = "com.mbartl.viplugineclipse.actions.EraseOneLevelOfIndentation";

	public EraseOneLevelOfIndentation() {
		setActionDefinitionId(ACTIONID);
	}
	
	public void run() {
		ViLayer layer = ViLayerManager.getInstance().getCurrentLayer();
		if (layer.isInInsertMode() || layer.isInReplaceMode()) {
			// shift left
			layer.getCommandBuffer().appendAndEval("<<");
		} else {
			// Page down
			new PageDown(1).execute();
		}
	}
}