/*******************************************************************************
 * Copyright (c) 2003-2004, Michael Bartl
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the license in the file License.txt
 * 
 * Created on 28.06.2004
 *******************************************************************************/

package com.mbartl.viplugineclipse.foldingextension;

import org.eclipse.jface.text.ITextViewer;
import org.eclipse.ui.texteditor.ITextEditor;

/**
 * Checks on which Platform the plugin is running and returns a new folding
 * extension instance depending on the configuration
 * 
 * @author Michael Bartl
 */
public class FoldingExtensionFactory {

    public static IFoldingExtension getFoldingExtension(ITextEditor editor,
            ITextViewer viewer) {
        String version = System.getProperty("osgi.framework.version");
        if (version.startsWith("3.0")) {
            try {
                return new FoldingExtension(editor, viewer);
            } catch (Exception e) {
                // no folding enabled => return NullFoldingExtension
            }
        }
        return new NullFoldingExtension();
    }
}