/*******************************************************************************
 * Copyright (c) 2003-2004, Michael Bartl
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the license in the file License.txt
 * 
 * Created on 28.06.2004
 *******************************************************************************/

package com.mbartl.viplugineclipse.foldingextension;

import com.mbartl.viimplementation.util.Region;

/**
 * The NullFoldingExtension is used for all TextEditors that do not utilize the
 * Eclipse folding extension (e.g. TextEditors before Eclipse 3.0)
 * 
 * @author Michael Bartl
 */
public class NullFoldingExtension implements IFoldingExtension {

    public int getValidCaretPosition(int pos, boolean forward) {
        return pos;
    }

    public int cursorOffset2DocumentOffset(int cursorPosition) {
        return cursorPosition;
    }

    public Region model2viewRegion(Region region) {
        return region;
    }
}