package com.mbartl.viplugineclipse.views;

import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Text;
import org.eclipse.ui.part.ViewPart;

public class CommandoView extends ViewPart {
    private Text _commandBuffer;

    private Label _info;

    private static CommandoView _view = null;

    /**
     * The constructor.
     */
    public CommandoView() {
        _view = this;
    }

    public static CommandoView getDefault() {
        return _view;
    }

    /**
     * This is a callback that will allow us to create the viewer and initialize
     * it.
     */
    public void createPartControl(Composite parent) {
        parent.setLayout(new FillLayout(SWT.VERTICAL));
        _commandBuffer = new Text(parent, SWT.LEAD);
        _commandBuffer.setEditable(true);
        _info = new Label(parent, SWT.LEAD);
    }

    /**
     * Passing the focus request to the view's control.
     */
    public void setFocus() {
        _commandBuffer.setFocus();
    }

    /**
     * set the given message into the info field (similar to the status bar)
     * 
     * @param message
     */
    public void setMessage(String message) {
        if (!_info.isDisposed()) {
            _info.setText(message);
        }
    }

    /**
     * set the given text into the edit field
     * 
     * @param text
     */
    public void setText(String text) {
        if (!_commandBuffer.isDisposed()) {
            _commandBuffer.setText(text);
        }
    }
}